<template>
  <div class="fr-col-lg-12">
    <FrTitle larger class="fr-mb-4w">Actualités de l’Incubateur</FrTitle>
    <FrSubTitle class="fr-mb-6w">
      Voici les dernières actualités de l’incubateur des territoires de l’ANCT.
    </FrSubTitle>

    <div class="fr-container fr-px-0 fr-mb-6w">
      <FrCardsContainer class="fr-mx-0">
        <FrCard
          v-for="(card, index) in cards"
          :key="`news-card${index}`"
          class="fr-col-lg-4"
          :to="card.to"
          :title="card.title"
          :description="card.description"
          :detail="card.detail"
          :image-path="card.image"
          enlarge-link
        />
      </FrCardsContainer>
    </div>
  </div>
</template>

<script>
import FrTitle from '~/components/ui/Title';
import FrSubTitle from '~/components/ui/SubTitle';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';
import { DEFAULT_DATE_FORMAT, LOCALE } from '~/config/locale';

export default {
  name: 'NewsPage',

  components: { FrSubTitle, FrTitle, FrCard, FrCardsContainer },

  async asyncData({ $axios, $config }) {
    const { data } = await $axios.$get('/items/actualites', {
      params: {
        fields: 'id,title,description,image,slug,publication_date',
        filter: { status: { _eq: 'published' } },
        sort: '-publication_date',
      },
    });

    const cards = data.map(
      ({ title, description, image, slug, publication_date }) => {
        const detail = new Date(publication_date).toLocaleString(
          LOCALE,
          DEFAULT_DATE_FORMAT,
        );

        return {
          detail,
          title,
          description,
          image: image
            ? `${$config.apiURL}/assets/${image}`
            : `${$config.apiURL}/assets/bee81aba-da05-4390-9cf0-f88591df9267`,
          to: { name: 'actualites-slug', params: { slug } },
        };
      },
    );

    return { cards };
  },

  data() {
    return {
      cards: [],
    };
  },
};
</script>
